Description

I am using Redmine 2.2.4. Thanks for the great open source tool.

I would like to find new issues that have been added, but not updated. I tried to use the filter "updated" set to "none". I know there are

issues without any update, but I always get "No data to display" message.

A little poking around the DB showed me that updated_on is set to created_on timestamp. So updated_on is not empty for new

issues. Looking at the code, I noticed there is before_save 'force_updated_on_change' function in issue model. I am guessing that is

setting the update_on field for new issues as well.

This seems incorrect, since clearly we wanted to query the issues with empty 'updated_on' field, as it is available in the filters. Can

someone help fix this?

Associated revisions

Revision 16226 - 2017-01-18 15:57 - Jean-Philippe Lang

Searching for issues with "updated = none" always returns zero results (#15226).

Patch by Marius BALTEANU.

History

#1 - 2013-10-30 10:58 - Gurvan Le Dromaguet

I would not say having "updated"="created" set at issue creation is incorrect, it is a question of how you see things :)

There can be other queries where I want to see the recent issue activity, I will query "updated today" and get also the issue created, which is what I

want.

That said, querying the issue not updated yet should be possible, maybe the query engine can allow having filter like "updated_on" = "created"

implemented some way ?

#2 - 2013-10-31 08:22 - Ketki Vahalia

I agree that it is not necessarily incorrect to have "update time = creation time". The gap is that the query feature has the option of selecting "none" for

updated_on field, but it will never be "none".

Either we allow a query where "update_on = created_on", or we set updated_on to null on creation.

#3 - 2013-10-31 14:24 - Etienne Massip

- Status changed from New to Confirmed

- Target version set to Candidate for next minor release

Ketki Vahalia wrote:

I agree that it is not necessarily incorrect to have "update time = creation time". The gap is that the query feature has the option of selecting

"none" for updated_on field, but it will never be "none".

 That's a true defect, indeed.

Either we allow a query where "update_on = created_on", or we set updated_on to null on creation.

 Would be easier to handle the "none" case as "update_on = created_on" behind the scenes (or replace it with some "never" entry for vocabulary

consistency with other filters).
#4 - 2013-11-05 06:17 - Ketki Vahalia

I am new to Ruby and Rails (am an embedded systems engineer by training and experience). Can someone give me a pointer on where to look in the

code. I can possibly fix this myself, if given some help. Thanks!

#5 - 2017-01-17 09:31 - Marius BĂLTEANU

- File fix_updated_on_by_none_or_any.patch added

The attached patch fixes the behavior for none and any operators as following:

none: returns all issues without updates (updated_on = created_on)

any: returns all issues that have an update (updated_on > created_on)

#6 - 2017-01-17 09:34 - Marius BĂLTEANU

- File fix_updated_on_by_none_or_any_v2.patch added

Attached new version with a small fix (replaced in test the word bigger with greater).

#7 - 2017-01-17 10:24 - Go MAEDA

- File 15226-ui-inconsistency.png added

Thanks Marius, the patch works fine. But I have found a UI issue.

Although the filter is set to "none", values are displayed in "Updated" column. I think that it is natural that nothing is displayed there if the filter is set to

"none".

 

#8 - 2017-01-17 10:48 - Marius BĂLTEANU

Go MAEDA wrote:

Although the filter is set to "none", values are displayed in "Updated" column. I think that it is natural that nothing is displayed there if the filter is

set to "none".

 I think that we should discuss this UI issue in a separate issue because it is a general UI issue, not only when having the Updated none filter.

Do you consider natural to have values in the "Updated" column for every issue without updates even if this filter is not set?

#9 - 2017-01-17 10:55 - Go MAEDA

Marius BALTEANU wrote:

Do you consider natural to have values in the "Updated" column for every issue without updates even if this filter is not set?

 No, it is very strange. I can understand what you are saying. Currently, I have no idea to resolve this UI issue.
#10 - 2017-01-17 16:20 - Go MAEDA

- Target version changed from Candidate for next minor release to 3.4.0

Although the patch has a small UI issue (#15226#note-7), I think it is a bigger problem that filter "updated = none" does not work.

Setting target version to 3.4.0.

#11 - 2017-01-17 17:44 - Kush Suryavanshi

Please correct me if I am wrong - It seems that Created = Updates for new issues is the design choice, hence current behaviour is expected. If we

need to apply this patch, shouldn't we reconsider the original design decision? i.e. dont enter updated date when a new issue is added? I think the

current solution may potentially confuse our users.(because it's been inconsistent with filters of other date fields)

#12 - 2017-01-17 18:31 - Marius BĂLTEANU

Kush Suryavanshi wrote:

Correct me if I am wrong - It seems that Created = Updates for new issues is the design choice, hence current behaviour is expected. If we need

to apply this patch, shouldn't we reconsider the original design decision? i.e. dont enter updated date when a new issue is added?

 Yes, it seems a design choice, but from my checks it has more implications.

In my opinion, we can solve the UI issue by hiding the update date for issues without updates (created = updated), but I prefer to wait for

Jean-Philippe Lang feedback before creating the patch.

#13 - 2017-01-18 16:00 - Jean-Philippe Lang

- Status changed from Confirmed to Closed

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Marius BALTEANU wrote:

In my opinion, we can solve the UI issue by hiding the update date for issues without updates (created = updated), but I prefer to wait for

Jean-Philippe Lang feedback before creating the patch.

 I agree, the updated_on column is filled by Rails on the issue creation, I don't want to change that. But it's still possible to hide the timestamp on the

issue list if it equals created_on. Not sure if it's a desirable change.

Your patch that fixes the filter is committed anyway, thanks.

#14 - 2017-01-18 19:35 - Kush Suryavanshi

Ok. Thanks both of you for clarification. I think we can solve the UI issue through JavaScript, at least for us.

Files

fix_updated_on_by_none_or_any.patch 1.7 KB 2017-01-17 Marius BĂLTEANU

fix_updated_on_by_none_or_any_v2.patch 1.7 KB 2017-01-17 Marius BĂLTEANU

15226-ui-inconsistency.png 21.9 KB 2017-01-17 Go MAEDA
